LogTo("/home/agustin/Dropbox/math/in-progress/GKdim_rk3/gap/new/triangles.log");;

#we invoke the file basic.g:
Read("/home/agustin/Dropbox/math/in-progress/GKdim_rk3/gap/new/basic.g");

Print("\n This file deals with triangles \n");;

tri:=function(d,f,g)
if d[3]=f[1] and f[3]=g[1] and g[3]=d[1] then return
Concatenation(d,[f[2],f[3],g[2]]);
else return
0;
fi;
end;

Print("\n Case 1: all edges are finite \n");;

#we collect all triangles on a list "tris"
tris:=[];;
for d in Hff do
for f in Hff do
for g in Hff do
if tri(d,f,g)<>0 then
Add(tris,tri(d,f,g));
fi;
od;
od;
od;

tris:=Set(tris);;
 
#we keep only those triangles that are triangles under simple reflections.
triss:=[];;
for d in tris do
if s(1,d)[6]<>F1 and s(2,d)[6]<>F1 and s(3,d)[6]<>F1 then
Add(triss,d);
fi;
od;
 
 
Print("\n \n We collect them all on a list, which has \n");; 
Print(Number(triss));
Print("\n  elements \n");; 
#106


l1:=[];
for d in triss do
if testall(d)=1 then
Add(l1,d);
fi;
od;


Print("\n \n We have \n");; 
Print(Number(l1));
Print("\n remaining elements, namely \n");; 
Display(l1); 
#0

Print("\n Case 2: two edges are finite \n");;

#we collect all triangles on a list "tris"
tris:=[];;
for d in Hff do
for f in Hff do
for g in Hqev do
if tri(d,f,g)<>0 then
Add(tris,tri(d,f,g));
fi;
od;
od;
od;

tris:=Set(tris);;
 
#we keep only those triangles that are triangles under simple reflections.
triss:=[];;
for d in tris do
if s(1,d)[6]<>F1 and s(2,d)[6]<>F1 and s(3,d)[6]<>F1 then
Add(triss,d);
fi;
od;
 
 
Print("\n \n We collect them all on a list, which has \n");; 
Print(Number(triss));
Print("\n  elements \n");; 
#4286


l2:=[];
for d in triss do
if testall(d)=1 then
Add(l2,d);
fi;
od;


Print("\n \n We have \n");; 
Print(Number(l2));
Print("\n remaining elements, namely \n");; 
Display(l2); 

Print("\n Case 3: only one edge is finite \n");;

#we collect all triangles on a list "tris"
tris:=[];;
for d in Hff do
for f in Hqev do
for g in Hqev do
if tri(d,f,g)<>0 then
Add(tris,tri(d,f,g));
fi;
od;
od;
od;

tris:=Set(tris);;
 
#we keep only those triangles that are triangles under simple reflections.
triss:=[];;
for d in tris do
if s(1,d)[6]<>F1 and s(2,d)[6]<>F1 and s(3,d)[6]<>F1 then
Add(triss,d);
fi;
od;
 
 
Print("\n \n We collect them all on a list, which has \n");; 
Print(Number(triss));
Print(" \n elements \n");; 
#?????


l3:=[];
for d in triss do
if testall(d)=1 then
Add(l3,d);
fi;
od;


Print("\n \n We have \n");; 
Print(Number(l3));
Print("\n remaining elements, namely \n");; 
Display(l3); 



Print("\n Case 4: all edges are parametric \n");;


Print("\n We work with subcases \n");;


Print("\n Case 4a: at least one edge is d2 \n");;

dd:=d2q;;

Hqevn:=[];
for p in Gf do
if dd(p)[1]<>F1 and dd(p)[2]<>F1 and dd(p)[3]<>F1 then
Add(Hqevn,dd(p));
fi;
od;
Hqevn:=Set(Hqevn);;

Hqevp:=Hqev;;

#we collect all triangles on a list "tris"
tris:=[];;
for d in Hqevn do
for f in Hqevp do
for g in Hqev do
if tri(d,f,g)<>0 then
Add(tris,tri(d,f,g));
fi;
od;
od;
od;

tris:=Set(tris);;
 
#we keep only those triangles that are triangles under simple reflections.
triss:=[];;
for d in tris do
if s(1,d)[6]<>F1 and s(2,d)[6]<>F1 and s(3,d)[6]<>F1 then
Add(triss,d);
fi;
od;
 
 
Print("\n \n We collect them all on a list, which has \n");; 
Print(Number(triss));
Print(" \n elements \n");; 



l4a:=[];
for d in triss do
if testall(d)=1 then
Add(l4a,d);
fi;
od;

Print("\n \n We have \n");; 
Print(Number(l4a));
Print("\n remaining elements, namely \n");; 
Display(l4a); 


Print("\n Case 4b: at least one edge is d3a (and no one is d2) \n");;

dd:=d3aq;;

Hqevn:=[];
for p in Gf do
if dd(p)[1]<>F1 and dd(p)[2]<>F1 and dd(p)[3]<>F1 then
Add(Hqevn,dd(p));
fi;
od;
Hqevn:=Set(Hqevn);;

Hqp:=[d3aq,d3apq,d3bq,d4q,d4pq,d5q,d5pq,d6q,d6pq,d11q,d11pq];;

Hqevp:=[];
for d in Hqp do
for p in Gf do
if d(p)[1]<>F1 and d(p)[2]<>F1 and d(p)[3]<>F1 then
Add(Hqevp,d(p));
fi;
od;
od;
Hqevp:=Set(Hqevp);;

#we collect all triangles on a list "tris"
tris:=[];;
for d in Hqevn do
for f in Hqevp do
for g in Hqev do
if tri(d,f,g)<>0 then
Add(tris,tri(d,f,g));
fi;
od;
od;
od;

tris:=Set(tris);;
 
#we keep only those triangles that are triangles under simple reflections.
triss:=[];;
for d in tris do
if s(1,d)[6]<>F1 and s(2,d)[6]<>F1 and s(3,d)[6]<>F1 then
Add(triss,d);
fi;
od;
 
 
Print("\n \n We collect them all on a list, which has \n");; 
Print(Number(triss));
Print(" \n elements \n");; 


l4b:=[];
for d in triss do
if testall(d)=1 then
Add(l4b,d);
fi;
od;

Print("\n \n We have \n");; 
Print(Number(l4b));
Print("\n remaining elements, namely \n");; 
Display(l4b); 




Print("\n Case 4c: at least one edge is d4 (and no one is d2, d3a) \n");;

dd:=d4q;;

Hqevn:=[];
for p in Gf do
if dd(p)[1]<>F1 and dd(p)[2]<>F1 and dd(p)[3]<>F1 then
Add(Hqevn,dd(p));
fi;
od;
Hqevn:=Set(Hqevn);;

Hqp:=[d3bq,d4q,d4pq,d5q,d5pq,d6q,d6pq,d11q,d11pq];;

Hqevp:=[];
for d in Hqp do
for p in Gf do
if d(p)[1]<>F1 and d(p)[2]<>F1 and d(p)[3]<>F1 then
Add(Hqevp,d(p));
fi;
od;
od;
Hqevp:=Set(Hqevp);;

#we collect all triangles on a list "tris"
tris:=[];;
for d in Hqevn do
for f in Hqevp do
for g in Hqev do
if tri(d,f,g)<>0 then
Add(tris,tri(d,f,g));
fi;
od;
od;
od;

tris:=Set(tris);;
 
#we keep only those triangles that are triangles under simple reflections.
triss:=[];;
for d in tris do
if s(1,d)[6]<>F1 and s(2,d)[6]<>F1 and s(3,d)[6]<>F1 then
Add(triss,d);
fi;
od;
 
 
Print("\n \n We collect them all on a list, which has \n");; 
Print(Number(triss));
Print(" \n elements \n");; 


l4c:=[];
for d in triss do
if testall(d)=1 then
Add(l4c,d);
fi;
od;

Print("\n \n We have \n");; 
Print(Number(l4c));
Print("\n remaining elements, namely \n");; 
Display(l4c); 



Print("\n Case 4d: at least one edge is d5 (and no one is d2, d3a,d4) \n");;

dd:=d5q;;

Hqevn:=[];
for p in Gf do
if dd(p)[1]<>F1 and dd(p)[2]<>F1 and dd(p)[3]<>F1 then
Add(Hqevn,dd(p));
fi;
od;
Hqevn:=Set(Hqevn);;

Hqp:=[d3bq,d5q,d5pq,d6q,d6pq,d11q,d11pq];;

Hqevp:=[];
for d in Hqp do
for p in Gf do
if d(p)[1]<>F1 and d(p)[2]<>F1 and d(p)[3]<>F1 then
Add(Hqevp,d(p));
fi;
od;
od;
Hqevp:=Set(Hqevp);;

#we collect all triangles on a list "tris"
tris:=[];;
for d in Hqevn do
for f in Hqevp do
for g in Hqev do
if tri(d,f,g)<>0 then
Add(tris,tri(d,f,g));
fi;
od;
od;
od;

tris:=Set(tris);;
 
#we keep only those triangles that are triangles under simple reflections.
triss:=[];;
for d in tris do
if s(1,d)[6]<>F1 and s(2,d)[6]<>F1 and s(3,d)[6]<>F1 then
Add(triss,d);
fi;
od;
 
 
Print("\n \n We collect them all on a list, which has \n");; 
Print(Number(triss));
Print(" \n elements \n");; 


l4d:=[];
for d in triss do
if testall(d)=1 then
Add(l4d,d);
fi;
od;

Print("\n \n We have \n");; 
Print(Number(l4d));
Print("\n remaining elements, namely \n");; 
Display(l4d); 




Print("\n Case 4e: at least one edge is d6 (and no one is d2, d3a, d4, d5) \n");;

dd:=d6q;;

Hqevn:=[];
for p in Gf do
if dd(p)[1]<>F1 and dd(p)[2]<>F1 and dd(p)[3]<>F1 then
Add(Hqevn,dd(p));
fi;
od;
Hqevn:=Set(Hqevn);;

Hqp:=[d3bq,d6q,d6pq,d11q,d11pq];;

Hqevp:=[];
for d in Hqp do
for p in Gf do
if d(p)[1]<>F1 and d(p)[2]<>F1 and d(p)[3]<>F1 then
Add(Hqevp,d(p));
fi;
od;
od;
Hqevp:=Set(Hqevp);;

#we collect all triangles on a list "tris"
tris:=[];;
for d in Hqevn do
for f in Hqevp do
for g in Hqev do
if tri(d,f,g)<>0 then
Add(tris,tri(d,f,g));
fi;
od;
od;
od;

tris:=Set(tris);;
 
#we keep only those triangles that are triangles under simple reflections.
triss:=[];;
for d in tris do
if s(1,d)[6]<>F1 and s(2,d)[6]<>F1 and s(3,d)[6]<>F1 then
Add(triss,d);
fi;
od;
 
 
Print("\n \n We collect them all on a list, which has \n");; 
Print(Number(triss));
Print(" \n elements \n");; 


l4e:=[];
for d in triss do
if testall(d)=1 then
Add(l4e,d);
fi;
od;

Print("\n \n We have \n");; 
Print(Number(l4e));
Print("\n remaining elements, namely \n");; 
Display(l4e); 




Print("\n Case 4f: at least one edge is d11 (and no one is d2, d3a, d4, d5, d6) \n");;

dd:=d11q;;

Hqevn:=[];
for p in Gf do
if dd(p)[1]<>F1 and dd(p)[2]<>F1 and dd(p)[3]<>F1 then
Add(Hqevn,dd(p));
fi;
od;
Hqevn:=Set(Hqevn);;

Hqp:=[d3bq,d11q,d11pq];;

Hqevp:=[];
for d in Hqp do
for p in Gf do
if d(p)[1]<>F1 and d(p)[2]<>F1 and d(p)[3]<>F1 then
Add(Hqevp,d(p));
fi;
od;
od;
Hqevp:=Set(Hqevp);;

#we collect all triangles on a list "tris"
tris:=[];;
for d in Hqevn do
for f in Hqevp do
for g in Hqev do
if tri(d,f,g)<>0 then
Add(tris,tri(d,f,g));
fi;
od;
od;
od;

tris:=Set(tris);;
 
#we keep only those triangles that are triangles under simple reflections.
triss:=[];;
for d in tris do
if s(1,d)[6]<>F1 and s(2,d)[6]<>F1 and s(3,d)[6]<>F1 then
Add(triss,d);
fi;
od;
 
 
Print("\n \n We collect them all on a list, which has \n");; 
Print(Number(triss));
Print(" \n elements \n");; 


l4f:=[];
for d in triss do
if testall(d)=1 then
Add(l4f,d);
fi;
od;

Print("\n \n We have \n");; 
Print(Number(l4f));
Print("\n remaining elements, namely \n");; 
Display(l4f); 


Print("\n Case 4g: all edges are d3b; is treated with other methods.\n");;


###################################

l4:=Concatenation(l4a,l4b,l4c,l4d,l4e,l4f);;
l4:=Set(l4);;

ll:=Concatenation(l1,l2,l3,l4);;
ll:=Set(ll);;

tt:=per(ll);;


Print("\n \n After removing repetitions, permutations and reflections, we have, in total: \n");; 
Print(Number(tt));
Print("\n remaining elements, namely \n");; 
Display(tt); 

